--- src/org/apache/xml/utils/XMLReaderManager.java.backup	2006-09-18 11:40:15.000000000 +0200
+++ src/org/apache/xml/utils/XMLReaderManager.java	2006-09-18 11:39:44.000000000 +0200
@@ -150,10 +150,16 @@
      * @param reader The XMLReader that's being released.
      */
     public synchronized void releaseXMLReader(XMLReader reader) {
+        // To avoid NullPointerException if reader is null
+        if (reader == null) {
+           return;
+        }
         // If the reader that's being released is the cached reader
         // for this thread, mark it as no longer being in use.
         if (m_readers.get() == reader) {
+            m_readers.set(null);
             m_inUse.put(reader, Boolean.FALSE);
         }
+        m_inUse.remove(reader);
     }
 }
